<template>
    <div class="addCoin row">
        <button class="btnAdd row" @click="isOpenMeth(), inputValue = '' "><div>Add Coin</div></button> 
        <div>
            <input v-model="inputValue" type="text" placeholder="for example: 'bitcoin' or 'btc'" :className="isOpenClass()">
            <div v-if="inputValue != '' " class="serchingList">
                <div v-if="searchingList.length" class="list">
                    <div v-for="coin in searchingList" @click="addCoin(coin), inputValue = ''" :key="coin.symbol" class="serchingItem">{{coin.symbol}}, {{coin.name}}</div>
                </div>
                <div v-else class="notMatch">
                    <div class="serchingItem">Not Match</div>
                </div>
            </div>
        </div>
        <button class="btnAdd icon" @click="isOpenMeth(), inputValue = '' "><div :className="'plus ' + isOpenClass()"></div></button> 
    </div> 
</template>

<script>
    import {getCoinsShortList} from './getCoinsShortList';
    import { mapMutations, mapGetters } from 'vuex';
    import { getLogo } from './getLogo';

    export default {
        data() {
            return {
                isOpen: false,
                inputValue: '',
                coinsList: [],
                isFavValue: false
            }
        }, 
        methods: {
            ...mapMutations(['addingCoin']),
            isOpenMeth() {this.isOpen ? this.isOpen = false : this.isOpen = true},
            isOpenClass() {
                if (this.isOpen) { return 'opened' }
                else { return'closed' }
            },
            async getShortListMeth() {
                this.coinsList = await getCoinsShortList()
            },
            async addCoin(coin) { 
                const logoUrl = await getLogo(coin.symbol)
                this.isFavValue = false
                if (this.favList) {
                    this.favList.forEach(favItem => {
                        if (coin.symbol === favItem.symbol) {
                            this.isFavValue = true;
                        }
                    });
                }
                const addingCoin = {
                    name: coin.name,
                    symbol: coin.symbol,
                    logourl: logoUrl,
                    currentPrice: null,
                    lastPrice: 1, 
                    difference: '',
                    isSelected: null,
                    pricesArr: [],
                    isFav: this.isFavValue,
                }
                this.addingCoin(addingCoin)
            } 
        },
        mounted() {
            this.getShortListMeth()
            console.log('перестройка')
        },
        computed: {
            ...mapGetters(['favList']),
            searchingList() {
                return [...this.coinsList].filter(coin => coin.name.toLowerCase().includes(this.inputValue.toLowerCase()) || coin.symbol.toLowerCase().includes(this.inputValue.toLowerCase()))
            }
        }
    }
</script>

<style scoped>
    .addCoin {
        justify-content: start;
    }

    input {
    height: 30px;
    border: none;
    box-shadow: inset 1px 1px 5px gray;
    font-family: 'Orbitron', sans-serif;
    }
    input.closed {
        width: 0;
        transition: .3s ease-in;
        padding: 5px 0;
        height: 30px;
    }
    input.opened {
        width: 220px;
        height: 30px;
        transition: .3s ease-out;
        padding: 5px 12px;
    }
    input:focus {
        border: none;
        outline: none;
    }
    .btnAdd {
        background-color: gray;
        width: 140px;
        height: 40px;
        font-size: 18px;
        border-end-start-radius: 15px;
        border-start-start-radius: 15px;
        color: rgb(77, 77, 77);
        align-items: center;
        justify-content: space-around;
        border: none;
        font-family: 'Orbitron', sans-serif;
        text-shadow: 1px 1px 5px orange;
    }
    .icon {
        border-end-start-radius: 0;
        border-start-start-radius: 0;
        border-start-end-radius: 15px;
        border-end-end-radius: 15px;
        width: 45px;
        margin-right: 10px;
    }
    .plus {
        width: 30px;
        height: 30px;
        align-self: center;
        background-position: center;
        background-size: contain;
        background-repeat: no-repeat;
    }
    .addCoin div.closed {
        background-image: url(@/icon/plus.png);
        transition: .3s;
    }
    .addCoin div.opened {
        background-image: url(@/icon/cross.png);
        transition: .3s;
    }
    .serchingList {
        position: absolute;
    }
    .serchingItem {
        color: white;
        background-color: rgba(90, 90, 90, 0.9);
        padding: 5px;
        width: 234px;
    }
    .serchingItem:hover {
        background-color: rgba(90, 90, 90, 1);
        box-shadow: inset 1px 1px 5px rgb(187, 187, 187);
        
    }
</style>